/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package exemplo16;

import JPlay.Animation;
import JPlay.Body;
import JPlay.GameImage;
import JPlay.Keyboard;
import JPlay.Sound;
import JPlay.Sprite;
import JPlay.Window;
import java.awt.event.KeyEvent;

/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense - UFF - Brasil - 2010
 * Ciência da Computação
 */

public class Main
{
    //Detectando colisões, ao colidir aciona a animação da explosão e toca um som de explosão
    public static void main(String[] args)
    {
            Window janela = new Window(800,600);
            Keyboard keyboard = janela.getKeyboard();

            keyboard.addKey(KeyEvent.VK_A, Keyboard.DETECT_EVERY_PRESS);
            keyboard.addKey(KeyEvent.VK_D, Keyboard.DETECT_EVERY_PRESS);

            GameImage backGround = new GameImage("fundo.png");
            Body navioAbobora = new Body("navio.png", 2);
            Body navioAmarelo = new Body("navio2.png",2);
            Animation explosao = new Animation("explosao.png",20);

            //A animação será executada uma única vez
            explosao.setRepeatAnimation(false);

            navioAbobora.setPosition(500,250);
            navioAmarelo.setPosition(100,250);

            navioAmarelo.setMaxVelocityX(1);
            navioAbobora.setMaxVelocityX(1);

            boolean executando = true;
            boolean acionarExplosao = false;
            while(executando)
            {
                    backGround.draw();
                    if (acionarExplosao == false)
                    {
                            navioAbobora.draw();
                            navioAmarelo.draw();

                            navioAbobora.moveX();//use as setas direcionais

                            //O navio amarelo usará as teclas a,d para se movimentar para os lados
                            navioAmarelo.moveX(KeyEvent.VK_A, KeyEvent.VK_D);

                            char estado = navioAbobora.getStateOfX();
                            if(estado == Sprite.LEFT)
                                navioAbobora.setCurrFrame(0);
                            else
                                if(estado == Sprite.RIGHT)
                                    navioAbobora.setCurrFrame(1);

                            estado = navioAmarelo.getStateOfX();
                            if(estado == Sprite.LEFT)
                                navioAmarelo.setCurrFrame(0);
                            else
                                if(estado == Sprite.RIGHT)
                                    navioAmarelo.setCurrFrame(1);

                            if (navioAbobora.collided(navioAmarelo))
                            {
                                    acionarExplosao = true;
                                    new Sound("explosao.wav").play();
                                    //O explosao.setPosition(x,y) - serve para centralizar a explosão
                                    //entre os navios
                                    if(navioAbobora.getStateOfX() == Body.LEFT)
                                        explosao.setPosition( navioAbobora.x - navioAbobora.width - explosao.width/4, 150 );
                                    else
                                        if(navioAmarelo.getStateOfX() == Body.RIGHT)
                                            explosao.setPosition( navioAmarelo.x + navioAmarelo.width - explosao.width/2, 150 );
                            }
                    }
                    else
                    {
                        explosao.runAnimation();
                        explosao.draw();
                    }
                    janela.display();

                    if (explosao.isAnimationFinished())
                    {
                        //Não deixa a animação ser desenhada na tela, mas ela ainda faz parte do processamento
                        explosao.hide();
                    }

                    if ( keyboard.keyDown(Keyboard.ESCAPE_KEY) == true )
                        executando = false;
            }
            janela.exit();
    }
}
